找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1005|回复: 0

[分享] Extend curve

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 00:53:30 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        [CommandMethod("ExtendCurve", "exc", CommandFlags.Modal)]
        static public void testExtendCurve()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Database db = doc.Database;

            try
            {
                using (Transaction tr = db.TransactionManager.StartTransaction())
                {
                    PromptEntityOptions peo = new PromptEntityOptions("\nSelect boundary edge... >>");

                    PromptEntityResult exres;
                    exres = ed.GetEntity(peo);
                    if (exres.Status != PromptStatus.OK)
                        return;

                    Entity exent = (Entity)tr.GetObject(exres.ObjectId, OpenMode.ForRead);
                    if (exent == null)
                        return;
                    Curve excur = exent as Curve;
                    peo = new PromptEntityOptions("\nSelect curve to extend >>");

                    PromptEntityResult res;
                    res = ed.GetEntity(peo);
                    if (res.Status != PromptStatus.OK)
                        return;

                    Entity ent = (Entity)tr.GetObject(res.ObjectId, OpenMode.ForRead);
                    if (ent == null)
                        return;

                    if (ent.GetRXClass().DxfName == "SPLINE")
                    {
                        ed.WriteMessage("\nCould not extend the spline");
                        return;
                    }
                    Curve cur = ent as Curve;
                    Point3dCollection pts = new Point3dCollection();
                    cur.IntersectWith(excur, Intersect.ExtendThis, pts, 0, 0);
                    if (pts.Count == 0)
                    {
                       ed.WriteMessage("\nCurves aren't intersects each other");
                        return;
                    }

                    Point3d pt = pts[0];// ought be to correct this point with circle and closed polyline
                    
                    if (!cur.IsWriteEnabled)
                        cur.UpgradeOpen();

                    Point3d pp = cur.GetClosestPointTo(res.PickedPoint, false);

                    bool sofar = false;

                    if (pp.DistanceTo(pt) < pt.DistanceTo(cur.EndPoint))
                        sofar = true;

                    if (sofar)
                    {
                        cur.Extend(true, pt);
                    }
                    else
                    {
                        cur.Extend(false, pt);
                    }
                  
                    tr.Commit();
                }
            }
            catch (System.Exception ex)
            {
                ed.WriteMessage(ex.Message );
            }

        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:49 , Processed in 0.229579 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表